#define MidiChannel 1
;#define ICD
;#define MIDITHROUGHTEST
#include "..\midiLatch.asm"

		CBLOCK	0x0E0
		SforzandoMode	
		SforzandoTimerBass
		SforzandoTimerTreble
		SforzandoTime
		TremoloSpeed
		ChannelPressure
		ENDC

#define BassSforzandoOut	LATC,4
#define TrebleSforzandoOut	LATC,5

MidiInNoteOn2
;		scale velo
		RRNCF	MidiByte2
		ADDLW	0x02
		
		MOVF	MidiByte1,W
		SUBLW	(0x24-1)	; Off-by-one
		BNN		MidiInNoteOn2_
		MOVF	MidiByte1,W
		SUBLW	0x3B
		BN		MidiInNoteOn2_
		BRA 	MidiInNoteOn2Bass
	RETURN

MidiInNoteOn2_
		MOVF	MidiByte1,W
		SUBLW	(0x3C-1)	; Off-by-one
		BNN		MidiInNoteOn2__
		MOVF	MidiByte1,W
		SUBLW	0x5B
		BN		MidiInNoteOn2__
		BRA 	MidiInNoteOn2Treble
	RETURN

MidiInNoteOn2__
	RETURN


MidiInNoteOff2
	RETURN

MidiInNoteOn2Bass:
		movlw	0x05
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2BassOPVelo
		movlw	0x06
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2BassUPVelo
		movlw	0x09
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2BassOPPres
		movlw	0x0A
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2BassUPPres
	RETURN

MidiInNoteOn2BassOPVelo:
		BSF		BassSforzandoOut
		MOVFF	MidiByte2, SforzandoTimerBass;
	RETURN
MidiInNoteOn2BassUPVelo:
		BCF		BassSforzandoOut
		MOVFF	MidiByte2, SforzandoTimerBass;
	RETURN
MidiInNoteOn2BassOPPres:
		BSF		BassSforzandoOut
		MOVFF	ChannelPressure, SforzandoTimerBass;
	RETURN
MidiInNoteOn2BassUPPres:
		BCF		BassSforzandoOut
		MOVFF	ChannelPressure, SforzandoTimerBass;
	RETURN

MidiInNoteOn2Treble:
		movlw	0x05
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2TrebleOPVelo
		movlw	0x06
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2TrebleUPVelo
		movlw	0x09
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2TrebleOPPres
		movlw	0x0A
		subwf	SforzandoMode,W
		bz		MidiInNoteOn2TrebleUPPres
	RETURN

MidiInNoteOn2TrebleOPVelo:
		BSF		TrebleSforzandoOut
		MOVFF	MidiByte2,SforzandoTimerTreble;
	RETURN
MidiInNoteOn2TrebleUPVelo:
		BCF		TrebleSforzandoOut
		MOVFF	MidiByte2,SforzandoTimerTreble;
	RETURN
MidiInNoteOn2TrebleOPPres:
		BSF		TrebleSforzandoOut
		MOVFF	ChannelPressure,SforzandoTimerTreble;
	RETURN
MidiInNoteOn2TrebleUPPres:
		BCF		TrebleSforzandoOut
		MOVFF	ChannelPressure,SforzandoTimerTreble;
	RETURN

MidiInCtrlChange:
		movlw	0x07; 			CC Volume
		subwf	MidiByte1,0;
		bz		MidiInCCVol;
		movlw	0x7B; 			CC NotesOff
		subwf	MidiByte1,0;
		bz		MidiInCCAllNotesOff;
		movlw	0x0A;			CC MidiInCCSforzandoMode
		subwf	MidiByte1,0;
		bz		MidiInCCSforzandoMode;
		movlw	0x0B;			CC MidiInCCTremoloSpeed
		subwf	MidiByte1,0;
		bz		MidiInCCTremoloSpeed;
	return

; c 64 -> 50Hz
; c 100

MidiInCCVol:
		movf	MidiByte2,W
		MULLW	0xA4
		MOVF	PRODH,W
		XORLW	0x7F
		movwf	CCPR1L;
	return
	
MidiInCCTremoloSpeed
		MOVF	MidiByte2,W	
		SUBLW	0x90;
		MOVWF	TremoloSpeed
	return

MidiInCCSforzandoMode:
		movff	MidiByte2,SforzandoMode	
		movlw	0x00
		subwf	SforzandoMode,W
		bz		SforzandoModeOP
		movlw	0x05
		subwf	SforzandoMode,W
		bz		SforzandoModeOP
		movlw	0x06
		subwf	SforzandoMode,W
		bz		SforzandoModeUP
		movlw	0x09
		subwf	SforzandoMode,W
		bz		SforzandoModeOP
		movlw	0x0A
		subwf	SforzandoMode,W
		bz		SforzandoModeUP
		movlw	0x10
		subwf	SforzandoMode,W
		bz		SforzandoModeLFO
	RETURN

SforzandoModeOP:
		BCF		BassSforzandoOut
		BCF		TrebleSforzandoOut
	RETURN

SforzandoModeUP:
		BSF		BassSforzandoOut
		BSF		TrebleSforzandoOut
	RETURN

Timer1ISR:
		BCF		PIR1,TMR1IF
		CLRF	TMR1L	; preset timer
		MOVLW	0xE0
		MOVWF	TMR1H	; preset timer
		movlw	0x05
		subwf	SforzandoMode,W
		bz		Timer1ISRModeOP
		movlw	0x06
		subwf	SforzandoMode,W
		bz		Timer1ISRModeUP
		movlw	0x09
		subwf	SforzandoMode,W
		bz		Timer1ISRModeOP
		movlw	0x0A
		subwf	SforzandoMode,W
		bz		Timer1ISRModeUP
		movlw	0x10
		subwf	SforzandoMode,W
		bz		Timer1ISRModeTremolo
	BRA		EndLowInt

Timer1ISRModeOP:
		;bass
		MOVF	SforzandoTimerBass,W
		BZ		Timer1ISRModeOPTreble
		DCFSNZ	SforzandoTimerBass
		BCF		BassSforzandoOut
		;treble
Timer1ISRModeOPTreble:
		MOVF	SforzandoTimerTreble,W
		BZ		LEndLowInt
		DCFSNZ	SforzandoTimerTreble
		BCF		TrebleSforzandoOut
	BRA		EndLowInt

Timer1ISRModeUP:
		;bass
		MOVF	SforzandoTimerBass,W
		BZ		Timer1ISRModeUPTreble
		DCFSNZ	SforzandoTimerBass
		BSF		BassSforzandoOut
Timer1ISRModeUPTreble
		;treble
		MOVF	SforzandoTimerTreble,W
		BZ		LEndLowInt
		DCFSNZ	SforzandoTimerTreble
		BSF		TrebleSforzandoOut
	BRA		EndLowInt

LEndLowInt
	BRA		EndLowInt

Timer1ISRModeTremolo:
		DECFSZ	SforzandoTimerBass
		BRA		EndLowInt	
		BTG		BassSforzandoOut
		BTFSS	BassSforzandoOut
		BCF		TrebleSforzandoOut
		BTFSC	BassSforzandoOut
		BSF		TrebleSforzandoOut
		MOVFF	TremoloSpeed,SforzandoTimerBass
	BRA		EndLowInt	

SforzandoModeLFO:
	RETURN

UserInit:
; pwm init
		movlw	0x80;
		movwf	PR2;
		movlw	0x7F;
		movwf	CCPR1L;
		movlw	0x01;
		movwf	TMR2;
		movlw	0x04;
		movwf	T2CON;
		movlw	0x0C;
		movwf	CCP1CON;
		CLRF	SforzandoMode	
		MOVLW	0x80
		MOVWF	TremoloSpeed
		MOVLW	0x50
		MOVWF	ChannelPressure


		; Timer1 setup
		MOVLW	0x31
		MOVWF	T1CON;
		BCF		PIR1,TMR1IF
		BCF		IPR1,TMR1IP	; Timer 1 is low priority
		BSF		PIE1,TMR1IE	; Timer 1 interupt enable
		BSF		INTCON,PEIE ;
		BSF		RCON, IPEN ; interrupt priorities enabled
		BSF		PIR1,TMR1IF
	RETURN

MidiInChannelPressure:
		RRNCF	MidiByte1,W
		ADDLW	0x01
		MOVWF 	ChannelPressure;
	RETURN

MidiInProgramChange:
MidiInRTReset:
MidiInRTActiveSense:
MidiInRTStop:
MidiInRTContinue:
MidiInRTStart:
MidiInRTTick:
MidiInRTClock:
MidiInTuneRequest:
MidiInAfterTouch:
MidiInPitchWheel:
MidiInSysExStart:
MidiInSysExByte:
MidiInSysExEnd:
	RETURN


;*************************************************************
;  latch pointer per note
	org 1000h	;	
NoteLatchPtr:
	DB	0,0,0,0,0,0,0,0; 0..7
	DB	0,0,0,0,0,0,0,0; 8..
	DB	0,0,0,0,0,0,0,0; 16..
	DB	0,0,0,0,0,0,0,ExtLatHData; 24..
	DB	0,0,0,0	;32..
	DB	ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData; 36..
	DB	ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData; 44..
	DB	ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData; 52..
	DB	ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData; 60..
	DB	ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData; 68..
	DB	ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData; 76..
	DB	ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData; 84..
	DB	ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,0; 92..
	DB	0,0,0,0; 100..
	DB	0,0,0,0,0,0,0,0; 104..
	DB	0,0,0,0,0,0,0,0; 112..
	DB	0,0,0,0,0,0,0,0; 120..127

	org 1100h	;	
NoteLatchOnOrMask:
	DB	0,0,0,0,0,0,0,0; 0..7
	DB	0,0,0,0,0,0,0,0; 8..
	DB	0,0,0,0,0,0,0,0; 16..
	DB	0,0,0,0,0,0,0,0x01; 24..
	DB	0,0,0,0; 32 ..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 36..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 44..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 52..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 60..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 68..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 76..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 84..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0; 92..
	DB	0,0,0,0; 100..
	DB	0,0,0,0,0,0,0,0; 104..
	DB	0,0,0,0,0,0,0,0; 112..
	DB	0,0,0,0,0,0,0,0; 120..127

	org 1200h	;	
NoteLatchOffAndMask:
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 0..7
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 8..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 16..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE; 24..
	DB	0xFF,0xFF,0xFF,0xFF; 28..	
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 36..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 44..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 52..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 60..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 68..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 76..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 84..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 92..
	DB	0xFF,0xFF,0xFF,0xFF; 100..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 104..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 112..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 120..127


	END
